<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;


use Zeedhi\Framework\DTO\Response;

use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RecebimentoServices;
use Teknisa\MAN\Utilities\Util;
use Zeedhi\Framework\Util\Functions;

class Recebimento {
    protected $dataSourceName = 'vnd0160J_relvendarecebimentofilial';
    protected $recebimento;
    protected $utilService;
    
    public function __construct (RecebimentoServices $recebimento, Util $utilService) {
        $this->recebimento = $recebimento;
        $this->utilService = $utilService;
    }
    
    public function getRecebimento(Request\Filter $request, Response $response) {
        try {
            $result = [];
            
            $conditions = $this->utilService->getParamsAsArray($request);
            
            if(isset($conditions['TIPORELATORIO']) && !empty($conditions['TIPORELATORIO'])) {
                if($conditions['TIPORELATORIO'] === 'A'){
                    if(!Functions::arrayKeyExists('CDLOJA', $conditions)){
                        $conditions['CDLOJA'] = null;
                    }
                    if( Functions::arrayKeyExists('CDFILIAL', $conditions) && 
                        Functions::arrayKeyExists('DTENTRVENDA', $conditions) &&
                        $conditions['CDFILIAL'] !== null && 
                        $conditions['DTENTRVENDA'] !== null ) {
                            
                        if(Functions::arrayKeyExists('DTENTRVENDA', $conditions)) {
                            $conditions['P_DTINI'] = $conditions['DTENTRVENDA'][0];
                            $conditions['P_DTFIN'] = $conditions['DTENTRVENDA'][1];
                            unset($conditions['DTENTRVENDA']);
                        }
                        $result = $response->addDataSet(new DataSet("vnd0160J_relvendarecebimentofilial", $this->recebimento->buscaRecebimento($conditions['CDFILIAL'],$conditions['CDLOJA'],$conditions['P_DTINI'], $conditions["P_DTFIN"],$conditions["NRORG"])));
                    }
                } else if($conditions['TIPORELATORIO'] === 'S'){
                    $result = $response->addDataSet(new DataSet("vnd0160J_relvendarecebimentofilial", $this->recebimento->fetchSynthReport($conditions)));
                }
            }
            
            return $result;
            
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
        
    }
}