<?php
namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services\DayPartService;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Controller\CrudWithParameterBag;

class RelDayPartController  extends  CrudWithParameterBag{
    const dataSourceRel      = 'vnd03100_relDayPart';
    
    protected $parameterBagColumnsRel   = array('DTINI', 'DTFIN', 'CDFILIAL'),
              $utilService,
              $DayPartService;
              
    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Manager $dataSourceManager, DayPartService $DayPartService) {
        $this->crudService               = $crudService;
        $this->parameterBag              = $parameterBag;
        $this->entityManager             = $entityManager;
        $this->utilService               = $utilService;
        $this->dataSourceManager         = $dataSourceManager;
        $this->DayPartService            = $DayPartService;
    }
    
    
     public function findDayPartReport( $request,  $response) {
        $result = [];
        $conditions = $this->utilService->getParamsAsArray($request);
        if(isset($conditions['CDFILIAL']) && !empty($conditions['CDFILIAL'])) {
            $result = $this->DayPartService->buscaDayPart($conditions);
            $response->addDataSet(new DataSet("vnd03100_relDayPart", $result));
        }
        return $result;
    }
    
}
