<?php
namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Factories\CadVendedor as CadVendedorRepository;

class CadVendedor {

    protected $vendedorRepository;
    protected $entityManager;

    public function __construct(CadVendedorRepository $vendedorRepository, EntityManager $entityManager) {
        $this->vendedorRepository = $vendedorRepository;
        $this->entityManager = $entityManager;
    }
    
    public function getVendorAddress($cdven, $nrorg) {
        return $this->vendedorRepository->getEndevende($cdven, $nrorg);
    }
    
    public function getVendor($cdven) {
        return $this->vendedorRepository->getVendor($cdven);
    }
    
    public function validOperador($CDOPERADOR) {
        $params = array (
            ':CDOPERADOR' => $CDOPERADOR
        );
        return  $this->entityManager->getConnection()->fetchAll(self::VALIDAR_OPERADOR, $params);
    }
    
    const VALIDAR_OPERADOR = "
        SELECT 
          DISTINCT V.CDOPERADOR 
        FROM 
          VENDEDOR V 
        WHERE 
          V.CDOPERADOR = :CDOPERADOR
    ";
    
}